
_set_up:

;Atmega16_uart.c,9 :: 		void set_up() {
;Atmega16_uart.c,11 :: 		DDD0_bit=0;   //Rx
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	IN         R27, DDD0_bit+0
	CBR        R27, BitMask(DDD0_bit+0)
	OUT        DDD0_bit+0, R27
;Atmega16_uart.c,12 :: 		DDD1_bit=1;   //Tx
	IN         R27, DDD1_bit+0
	SBR        R27, BitMask(DDD1_bit+0)
	OUT        DDD1_bit+0, R27
;Atmega16_uart.c,13 :: 		DDB0_bit=1;   //DATA
	IN         R27, DDB0_bit+0
	SBR        R27, BitMask(DDB0_bit+0)
	OUT        DDB0_bit+0, R27
;Atmega16_uart.c,14 :: 		DDB1_bit=1;   //CLK
	IN         R27, DDB1_bit+0
	SBR        R27, BitMask(DDB1_bit+0)
	OUT        DDB1_bit+0, R27
;Atmega16_uart.c,15 :: 		PORTB1_bit=0;
	IN         R27, PORTB1_bit+0
	CBR        R27, BitMask(PORTB1_bit+0)
	OUT        PORTB1_bit+0, R27
;Atmega16_uart.c,16 :: 		PORTB0_bit=0;
	IN         R27, PORTB0_bit+0
	CBR        R27, BitMask(PORTB0_bit+0)
	OUT        PORTB0_bit+0, R27
;Atmega16_uart.c,17 :: 		UART1_Init(9600);
	LDI        R27, 103
	OUT        UBRRL+0, R27
	LDI        R27, 0
	OUT        UBRRH+0, R27
	CALL       _UART1_Init+0
;Atmega16_uart.c,18 :: 		Delay_ms(100);
	LDI        R18, 9
	LDI        R17, 30
	LDI        R16, 229
L_set_up0:
	DEC        R16
	BRNE       L_set_up0
	DEC        R17
	BRNE       L_set_up0
	DEC        R18
	BRNE       L_set_up0
	NOP
;Atmega16_uart.c,19 :: 		TM1637_Init();
	CALL       _TM1637_Init+0
;Atmega16_uart.c,20 :: 		TM1637_DisplayDecimal(num, 0); // 0: OFF 1: ON
	CLR        R4
	CLR        R5
	LDS        R2, _num+0
	LDS        R3, _num+1
	CALL       _TM1637_DisplayDecimal+0
;Atmega16_uart.c,21 :: 		UART1_Write_Text("Init");
	LDI        R27, #lo_addr(?lstr1_Atmega16_uart+0)
	MOV        R2, R27
	LDI        R27, hi_addr(?lstr1_Atmega16_uart+0)
	MOV        R3, R27
	CALL       _UART1_Write_Text+0
;Atmega16_uart.c,22 :: 		UART1_Write(13);UART1_Write(10);
	LDI        R27, 13
	MOV        R2, R27
	CALL       _UART1_Write+0
	LDI        R27, 10
	MOV        R2, R27
	CALL       _UART1_Write+0
;Atmega16_uart.c,23 :: 		}
L_end_set_up:
	POP        R5
	POP        R4
	POP        R3
	POP        R2
	RET
; end of _set_up

_main:
	LDI        R27, 255
	OUT        SPL+0, R27
	LDI        R27, 0
	OUT        SPL+1, R27

;Atmega16_uart.c,25 :: 		void main() {
;Atmega16_uart.c,26 :: 		set_up();
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	CALL       _set_up+0
;Atmega16_uart.c,27 :: 		do {
L_main2:
;Atmega16_uart.c,28 :: 		if (UART1_Data_Ready()) {      // If data is received,
	CALL       _UART1_Data_Ready+0
	TST        R16
	BRNE       L__main12
	JMP        L_main5
L__main12:
;Atmega16_uart.c,29 :: 		uart_rd = UART1_Read();      // read the received data,
	CALL       _UART1_Read+0
	STS        _uart_rd+0, R16
;Atmega16_uart.c,30 :: 		UART1_Write(uart_rd);        // and send data via UART
	MOV        R2, R16
	CALL       _UART1_Write+0
;Atmega16_uart.c,31 :: 		if(uart_rd == 'A') num++;
	LDS        R16, _uart_rd+0
	CPI        R16, 65
	BREQ       L__main13
	JMP        L_main6
L__main13:
	LDS        R16, _num+0
	LDS        R17, _num+1
	LDS        R18, _num+2
	LDS        R19, _num+3
	SUBI       R16, 255
	SBCI       R17, 255
	SBCI       R18, 255
	SBCI       R19, 255
	STS        _num+0, R16
	STS        _num+1, R17
	STS        _num+2, R18
	STS        _num+3, R19
L_main6:
;Atmega16_uart.c,32 :: 		if(uart_rd == 'B') num--;
	LDS        R16, _uart_rd+0
	CPI        R16, 66
	BREQ       L__main14
	JMP        L_main7
L__main14:
	LDS        R16, _num+0
	LDS        R17, _num+1
	LDS        R18, _num+2
	LDS        R19, _num+3
	SUBI       R16, 1
	SBCI       R17, 0
	SBCI       R18, 0
	SBCI       R19, 0
	STS        _num+0, R16
	STS        _num+1, R17
	STS        _num+2, R18
	STS        _num+3, R19
L_main7:
;Atmega16_uart.c,33 :: 		}
L_main5:
;Atmega16_uart.c,34 :: 		if(num>1000) num=0;
	LDS        R20, _num+0
	LDS        R21, _num+1
	LDS        R22, _num+2
	LDS        R23, _num+3
	LDI        R16, 232
	LDI        R17, 3
	LDI        R18, 0
	LDI        R19, 0
	CP         R16, R20
	CPC        R17, R21
	CPC        R18, R22
	CPC        R19, R23
	BRLT       L__main15
	JMP        L_main8
L__main15:
	LDI        R27, 0
	STS        _num+0, R27
	STS        _num+1, R27
	STS        _num+2, R27
	STS        _num+3, R27
L_main8:
;Atmega16_uart.c,35 :: 		if(num<0) num=1000;
	LDS        R20, _num+0
	LDS        R21, _num+1
	LDS        R22, _num+2
	LDS        R23, _num+3
	LDI        R16, 0
	LDI        R17, 0
	LDI        R18, 0
	LDI        R19, 0
	CP         R20, R16
	CPC        R21, R17
	CPC        R22, R18
	CPC        R23, R19
	BRLT       L__main16
	JMP        L_main9
L__main16:
	LDI        R27, 232
	STS        _num+0, R27
	LDI        R27, 3
	STS        _num+1, R27
	LDI        R27, 0
	STS        _num+2, R27
	STS        _num+3, R27
L_main9:
;Atmega16_uart.c,36 :: 		TM1637_DisplayDecimal(num, 0); // 0: OFF 1: ON
	CLR        R4
	CLR        R5
	LDS        R2, _num+0
	LDS        R3, _num+1
	CALL       _TM1637_DisplayDecimal+0
;Atmega16_uart.c,38 :: 		} while (1);
	JMP        L_main2
;Atmega16_uart.c,39 :: 		}
L_end_main:
	POP        R5
	POP        R4
	POP        R3
	POP        R2
L__main_end_loop:
	JMP        L__main_end_loop
; end of _main
